/*
Met dit programma worden oude CIMIRe gegevens opgehaald voor nog in leven zijnde individuen
*/
/*Zet gebruikersopties*/
%let LIB1       = D_cim01;                     /*bibliotheek met mimosis-gegevens*/
%let LIB2       = MIMOSIS; 
%let SubFile7   = mim2008_sample;          /*bestand met te gebruiken steekproef-nummers*/
%let SubFile1   = mim2008_cimire_t22_2001;
%let SubFile2   = mim2008_cimire_t23_2001;
%let SubFile3   = mim2008_cimire_t24_2001;
%let SubFile4   = mim2008_cimire_t25_2001;
%let SubFile5   = mim2008_cimire_t26_2001;

%let input1   = cimire_t22_2001_echantillon;
%let input2   = cimire_t23_2001_echantillon;
%let input3   = cimire_t24_2001_echantillon;
%let input4   = cimire_t25_2001_echantillon;
%let input5   = cimire_t26_2001_echantillon;


/*Macro voor conversie datum-variabelen naar waarden met enkel maand en jaar*/
%Macro DateManip(VarAnal,VarOut);

    LENGTH JAAR  $4.;
    LENGTH MAAND $2.;

    /*Manipuleer jaar indien nodig*/
    JAAR = PUT(YEAR(&VarAnal),4.);
    IF YEAR(&VarAnal) EQ . THEN DO;
        JAAR        = "    ";
    END;
    /*Manipuleer maand indien nodig*/
    IF MONTH(&VarAnal) LT 1     OR  MONTH(&VarAnal) EQ .   THEN MAAND = "  ";
    IF MONTH(&VarAnal) GE 1     AND MONTH(&VarAnal) LT 10  THEN MAAND = "0" || PUT(MONTH(&VarAnal),1.);
    IF MONTH(&VarAnal) GE 10    AND MONTH(&VarAnal) LT 13  THEN MAAND = PUT(MONTH(&VarAnal),2.);
    IF MONTH(&VarAnal) GE 13                               THEN MAAND = "  ";
    &VarOut = MAAND || "-" || JAAR;
%Mend DateManip;
%Macro NomValManip(VarAnal,VarOut,ClassVal);
    
    &VarOut = &VarAnal;
    IF &VarAnal NE . AND &VarAnal NE 0 THEN DO;
        IF &VarAnal GT 0 THEN &VarOut = %eval(&ClassVal)*INT((&VarAnal+%eval(&ClassVal))/%eval(&ClassVal));
        IF &VarAnal LT 0 THEN &VarOut = %eval(&ClassVal)*INT((&VarAnal-%eval(&ClassVal))/%eval(&ClassVal));
    END;
    
%Mend NomValManip;

/*Start macro die over files moet uitgevoerd worden*/
%MACRO ForEach;

    %DO I = 1 %to 5;

        DATA &LIB2..&&SubFile&I.;

            MERGE   &LIB1..&&input&I. (In=InA rename = (insz = gecodeerd_insz))
                    &LIB2..&SubFile7   (In=InB keep = insz rename = (insz = gecodeerd_insz))
            ;
            BY gecodeerd_insz;
            IF ina=1 and inb=1;
            
            %IF &I EQ 1 OR &I EQ 4 %THEN %DO;

                %NomValManip(remun_eur,remun_eur_class,10);
                DROP remun_eur;

            %END;

            %IF &I EQ 3 %THEN %DO;

                %NomValManip(salaire_base_eur,salaire_base_eur_class,10);
                DROP salaire_base_eur;

            %END;

			%IF &I = 3 %THEN %DO;

				%DateManip(date_1,date_1_&Year.);
				DROP date_1 jaar maand;
				%DateManip(date_2,date_2_&Year.);
				DROP date_2 jaar maand;
				date_3_&Year. = substr(date_3, 1 , 6);
				DROP date_3;

			%END;
 
			%IF &I = 5 %THEN %DO;

				%DateManip(date_1,date_1_&Year.);
				DROP date_1 jaar maand;
				%DateManip(date_2,date_2_&Year.);
				DROP date_2 jaar maand;
				%DateManip(date_3,date_3_&Year.);
				DROP date_3 jaar maand;

			%END;

			%IF &I = 2 %THEN %DO;

				%DateManip(date_deb,date_deb_&Year.);
				DROP date_deb jaar maand;
				%DateManip(date_fin,date_fin_&Year.);
				DROP date_fin jaar maand;

			%END;

 
        RUN;            

		data &LIB2..&&SubFile&I.;
			set &LIB2..&&SubFile&I. (rename = (gecodeerd_insz = insz));
		run;


    %END;

%MEND ForEach;
%ForEach;
