/*
Met dit programma voeren we manipulaties uit op de RSVZ inkomens data.
Voorlopig gewoon copie van data. Manipulaties zijn eventueel later nodig.

*/
/*Macro voor conversie datum-variabelen naar waarden met enkel maand en jaar*/
%Macro DateManip(VarAnal,VarOut);

    LENGTH JAAR  $4.;
    LENGTH MAAND $2.;

    /*Manipuleer jaar indien nodig*/
    JAAR = PUT(YEAR(&VarAnal),4.);
    IF YEAR(&VarAnal) EQ . THEN DO;
        JAAR        = "    ";
    END;
    /*Manipuleer maand indien nodig*/
    IF MONTH(&VarAnal) LT 1     OR  MONTH(&VarAnal) EQ .   THEN MAAND = "  ";
    IF MONTH(&VarAnal) GE 1     AND MONTH(&VarAnal) LT 10  THEN MAAND = "0" || PUT(MONTH(&VarAnal),1.);
    IF MONTH(&VarAnal) GE 10    AND MONTH(&VarAnal) LT 13  THEN MAAND = PUT(MONTH(&VarAnal),2.);
    IF MONTH(&VarAnal) GE 13                               THEN MAAND = "  ";
    &VarOut = MAAND || "-" || JAAR;
%Mend DateManip;
%Macro NomValManip(VarAnal,VarOut,ClassVal);
    
    &VarOut = &VarAnal;
    IF &VarAnal NE . AND &VarAnal NE 0 THEN DO;
        IF &VarAnal GT 0 THEN &VarOut = %eval(&ClassVal)*INT((&VarAnal+%eval(&ClassVal))/%eval(&ClassVal));
        IF &VarAnal LT 0 THEN &VarOut = %eval(&ClassVal)*INT((&VarAnal-%eval(&ClassVal))/%eval(&ClassVal));
    END;
    
%Mend NomValManip;

/*Start macro die over files moet uitgevoerd worden*/
%MACRO ForEach(EEJJK);

    /*Zet gebruikersopties*/
    %let EEJJ       = %SUBSTR(&EEJJK,1,4);
    %let Year       = %SUBSTR(&EEJJK,1,4);
    %let JJK        = %SUBSTR(&EEJJK,3,3);
    %let JJ         = %SUBSTR(&EEJJK,3,2);
    %let LIB1       = D_rsvz&JJ.;                   /*bibliotheek waar RSVZ-gegevens staan*/
    %let SubFile1   = RSVZ_INK_&Year;
    %let LIB2       = MIMOSIS;                     /*bibliotheek met mimosis-gegevens*/
    %let SubFile7   = mim2008_sample;          /*bestand met te gebruiken steekproef-nummers*/
    %let ResFile    = mim2008_RSVZInc;

    /*Start processing data of a given quarter*/
    DATA RSVZBasis;
        MERGE   &LIB1..&SubFile1   (In=InA rename = (insz = gecodeerd_insz))
                &LIB2..&SubFile7   (In=InB rename = (insz = gecodeerd_insz))
        ;
	by gecodeerd_insz;
	if InA=1 and InB=1;
    RUN;

    /*Maak eindbestand*/
    DATA &LIB2..&ResFile.&Year;

        SET RSVZBasis;

        LABEL GECODEERD_INSZ    = "Geanonimiseerd identificatienummer van het individu";

        /*Rename variables*/
        jaar_&Year. = jaar;
        %NomValManip(inkomens,inkomens_&Year.,10);

        /*Label variables*/
        LABEL jaar_&Year.       = "Jaar waarin het netto bedrijfsinkomen gegenereerd werd";
        LABEL inkomens_&Year.   = "Netto bedrijfsinkomsten van het jaar geregistreerd in de variabele jaar";

        KEEP
        GECODEERD_INSZ 
        jaar_&Year. 
        inkomens_&Year. 
        ;
        
    RUN;            
    
	data &LIB2..&ResFile.&Year;
		set &LIB2..&ResFile.&Year (rename = (gecodeerd_insz = insz));
	run;

%MEND ForEach;
%ForEach(20054);
%ForEach(20064);
%ForEach(20074);
%ForEach(20084);
